//+------------------------------------------------------------------+
//|                                                AutoDayFibs V1.3  |
//|                                                                  |
//|              Copyright  2005-2008, Jason Robinson (jnrtrading)  |
//|                                 http://www.spreadtrade2win.com   |
//|                                                                  |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                                  |
//|Options: AutomaticallyAdjustToToday (true/false);                 |
//|               Determine whether to have the indicator            |
//|               automatically adjust to todays prices.             |
//|         TimeToAdjust (in 24 hour format 0-23);                   |
//|               If AutomaticallyAdjustToToday is set               |
//|               to 'true' then you can determine at                |
//|               what time the fib lines switch to using            |
//|               todays prices instead of yesterdays.               |
//|               Works only for whole hours.                        |
//|         DaysBackForHigh and DaysBackForLow;                      |
//|               If AutomaticallyAdjustToToday is set               |
//|               to 'false' then you can adjust the                 |
//|               amount of days back to take the high               |
//|               and low readings from.                             |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005-2008, Jason Robinson (jnrtrading)"
#property link      "http://www.spreadtrade2win.com"

#property indicator_chart_window
extern bool   AutomaticallyAdjustToToday = false;
extern int    TimeToAdjust;
extern int    DaysBackForHigh            = 1;
extern int    DaysBackForLow             = 1;  
extern int    DaysBackForClose           = 1;
extern color  ColourOfLines              = clrPurple;
extern color  LabelsColor                = clrAquamarine;
extern bool   alertsOn                   = false;
extern bool   alertsOnPivotTouch         = false;
extern bool   alertsOnFibS1Touch         = false;
extern bool   alertsOnFibS2Touch         = false;
extern bool   alertsOnFibS3Touch         = false;
extern bool   alertsOnFibR1Touch         = false;
extern bool   alertsOnFibR2Touch         = false;
extern bool   alertsOnFibR3Touch         = false;
extern bool   alertsOnCurrent            = false;
extern bool   alertsMessage              = false;
extern bool   alertsSound                = true;
extern bool   alertsEmail                = false;
extern bool   alertsNotify               = true;
extern string soundFile                  = "Sound Effect - Police Siren 02.wav";

//
//
//
//
//

double trend1[];
double trend2[];
double trend3[];
double trend4[];
double trend5[];
double trend6[];
double trend7[];
double Rates[][6];

double prevRange;
bool   objectsExist, highFirst;

//---- buffers

       

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,trend1);
   SetIndexBuffer(1,trend2);
   SetIndexBuffer(2,trend3);
   SetIndexBuffer(3,trend4);
   SetIndexBuffer(4,trend5);
   SetIndexBuffer(5,trend6);
   SetIndexBuffer(6,trend7);
prevRange = 0;
objectsExist = false;
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
      ObjectDelete("pivot");
      ObjectDelete("pivot_label");
      ObjectDelete("fibs1");
      ObjectDelete("fibs1_label");
      ObjectDelete("fibs2");
      ObjectDelete("fibs2_label");
      ObjectDelete("fibs3");
      ObjectDelete("fibs3_label");
      ObjectDelete("fibr1");
      ObjectDelete("fibr1_label"); 
      ObjectDelete("fibr2");
      ObjectDelete("fibr2_label"); 
      ObjectDelete("fibr3");
      ObjectDelete("fibr3_label"); 
      
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{ 
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         
   //
   //
   //
   //
   //
   
   ArrayCopyRates(Rates, Symbol(), PERIOD_D1);   
   if (AutomaticallyAdjustToToday == true) 
   {
      if (Hour() >= 0 && Hour() < TimeToAdjust) 
      {
         DaysBackForHigh  = 1;
         DaysBackForLow   = 1;
         DaysBackForClose = 1;
      }
      else if (Hour() >= DaysBackForLow && Hour() <= 23) 
      {
         DaysBackForHigh  = 0;
         DaysBackForLow   = 0;
         DaysBackForClose = 0;
      }
   }
   double high  = Rates[DaysBackForHigh][3];
   double low   = Rates[DaysBackForLow][2];
   double close = Rates[DaysBackForClose][4]; 
   double pivot = (high + low + close) / 3;
   double range = high - low;
   
   for (i = 0; i < Bars; i++) 
   {
      if(High[i] == high) {
         highFirst = true;
         break;
      }
      else if(Low[i] == low) {
         highFirst = false;
         break;
      }
   //Print(highFirst);
   }
   // Delete Objects if necessary
   if (prevRange != range) 
   {
      ObjectDelete("pivot");
      ObjectDelete("pivot_label");
      ObjectDelete("fibs1");
      ObjectDelete("fibs1_label");
      ObjectDelete("fibs2");
      ObjectDelete("fibs2_label");
      ObjectDelete("fibs3");
      ObjectDelete("fibs3_label");
      ObjectDelete("fibr1");
      ObjectDelete("fibr1_label"); 
      ObjectDelete("fibr2");
      ObjectDelete("fibr2_label"); 
      ObjectDelete("fibr3");
      ObjectDelete("fibr3_label"); 
      
  
      objectsExist = false;
      prevRange    = range;
      //Print("Objects do not exist");
   }
   
   if (!highFirst) 
   {
      double fib000 = pivot;
      double fibs1  = pivot - (high - low)*0.382;
      double fibr1  = pivot + (high - low)*0.382;
      double fibs2  = pivot - (high - low)*0.618;
      double fibr2  = pivot + (high - low)*0.618;
      double fibs3  = pivot - (high - low)*1.0;
      double fibr3  = pivot + (high - low)*1.0;
   }
   else if (highFirst) 
   {
      fib000 = pivot;
      fibs1  = pivot - (high - low)*0.382;
      fibr1  = pivot + (high - low)*0.382;
      fibs2  = pivot - (high - low)*0.618;
      fibr2  = pivot + (high - low)*0.618;
      fibs3  = pivot - (high - low)*1.0;
      fibr3  = pivot + (high - low)*1.0;
   }
   
   if (!objectsExist) 
   {
       ObjectCreate("pivot", OBJ_HLINE, 0, Time[0], fib000);
          ObjectSet("pivot", OBJPROP_STYLE, STYLE_DOT);
          ObjectSet("pivot", OBJPROP_COLOR, ColourOfLines);
       ObjectCreate("pivot_label", OBJ_TEXT, 0, Time[0], fib000);
      ObjectSetText("pivot_label","                             P", 8, "Times", LabelsColor);
   
       ObjectCreate("fibs1", OBJ_HLINE, 0, Time[0], fibs1);
          ObjectSet("fibs1", OBJPROP_STYLE, STYLE_DOT);
          ObjectSet("fibs1", OBJPROP_COLOR, ColourOfLines);
       ObjectCreate("fibs1_label", OBJ_TEXT, 0, Time[0], fibs1);
      ObjectSetText("fibs1_label","                             S1", 8, "Times", LabelsColor);
      
       ObjectCreate("fibs2", OBJ_HLINE, 0, Time[0], fibs2);
          ObjectSet("fibs2", OBJPROP_STYLE, STYLE_DOT);
          ObjectSet("fibs2", OBJPROP_COLOR, ColourOfLines);
       ObjectCreate("fibs2_label", OBJ_TEXT, 0, Time[0], fibs2);
      ObjectSetText("fibs2_label","                             S2", 8, "Times", LabelsColor);
      
       ObjectCreate("fibs3", OBJ_HLINE, 0, Time[0], fibs3);
          ObjectSet("fibs3", OBJPROP_STYLE, STYLE_DOT);
          ObjectSet("fibs3", OBJPROP_COLOR, ColourOfLines);
       ObjectCreate("fibs3_label", OBJ_TEXT, 0, Time[0], fibs3);
      ObjectSetText("fibs3_label","                             S3", 8, "Times", LabelsColor);
      
       ObjectCreate("fibr1", OBJ_HLINE, 0, Time[0], fibr1);
          ObjectSet("fibr1", OBJPROP_STYLE, STYLE_DOT);
          ObjectSet("fibr1", OBJPROP_COLOR, ColourOfLines);
       ObjectCreate("fibr1_label", OBJ_TEXT, 0, Time[0], fibr1);
      ObjectSetText("fibr1_label","                             R1", 8, "Times", LabelsColor);
      
       ObjectCreate("fibr2", OBJ_HLINE, 0, Time[0], fibr2);
          ObjectSet("fibr2", OBJPROP_STYLE, STYLE_DOT);
          ObjectSet("fibr2", OBJPROP_COLOR, ColourOfLines);
       ObjectCreate("fibr2_label", OBJ_TEXT, 0, Time[0], fibr2);
      ObjectSetText("fibr2_label","                             R2", 8, "Times", LabelsColor);
      
       ObjectCreate("fibr3", OBJ_HLINE, 0, Time[0], fibr3);
          ObjectSet("fibr3", OBJPROP_STYLE, STYLE_DOT);
          ObjectSet("fibr3", OBJPROP_COLOR, ColourOfLines);
       ObjectCreate("fibr3_label", OBJ_TEXT, 0, Time[0], fibr3);
      ObjectSetText("fibr3_label","                             R3", 8, "Times", LabelsColor);
      
   }
   
   for(i=limit; i>=0; i--)
   {
      trend1[i] = trend1[i+1];
      trend2[i] = trend2[i+1];
      trend3[i] = trend3[i+1];
      trend4[i] = trend4[i+1];
      trend5[i] = trend5[i+1];
      if (Close[i]>=pivot)  trend1[i] = 1;
      if (Close[i]<=pivot)  trend1[i] =-1;
      if (Close[i]>=fibs1)  trend2[i] = 1;
      if (Close[i]<=fibs1)  trend2[i] =-1;  
      if (Close[i]>=fibs2)  trend3[i] = 1;
      if (Close[i]<=fibs2)  trend3[i] =-1;
      if (Close[i]>=fibs3)  trend4[i] = 1;
      if (Close[i]<=fibs3)  trend4[i] =-1; 
      if (Close[i]>=fibr1)  trend5[i] = 1;
      if (Close[i]<=fibr1)  trend5[i] =-1; 
      if (Close[i]>=fibr2)  trend6[i] = 1;
      if (Close[i]<=fibr2)  trend6[i] =-1; 
      if (Close[i]>=fibr3)  trend7[i] = 1;
      if (Close[i]<=fibr3)  trend7[i] =-1; 
   }
   
   //
   //
   //
   //
   //
   
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
      static datetime time1 = 0;
      static string   mess1 = "";
         if (alertsOnPivotTouch && trend1[whichBar] != trend1[whichBar+1])
         {
            if (trend1[whichBar] ==  1) doAlert(time1,mess1,whichBar," touching Pivot Fib up ");
            if (trend1[whichBar] == -1) doAlert(time1,mess1,whichBar," touching Pivot Fib down ");
         }            
      static datetime time2 = 0;
      static string   mess2 = "";
         if (alertsOnFibS1Touch && trend2[whichBar] != trend2[whichBar+1])
         {
            if (trend2[whichBar] ==  1) doAlert(time2,mess2,whichBar," touching S1 Fib up ");
            if (trend2[whichBar] == -1) doAlert(time2,mess2,whichBar," touching S1 Fib down ");
         }
         
      static datetime time3 = 0;
      static string   mess3 = "";
         if (alertsOnFibS2Touch && trend3[whichBar] != trend3[whichBar+1])
         {
            if (trend3[whichBar] ==  1) doAlert(time3,mess3,whichBar," touching S2 Fib up ");
            if (trend3[whichBar] == -1) doAlert(time3,mess3,whichBar," touching S2 Fib down ");
         }
      static datetime time4 = 0;
      static string   mess4 = "";
         if (alertsOnFibS3Touch && trend4[whichBar] != trend4[whichBar+1])
         {
            if (trend4[whichBar] ==  1) doAlert(time4,mess4,whichBar," touching S3 Fib up ");
            if (trend4[whichBar] == -1) doAlert(time4,mess4,whichBar," touching S3 Fib down ");
         }
      static datetime time5 = 0;
      static string   mess5 = "";
         if (alertsOnFibR1Touch && trend5[whichBar] != trend5[whichBar+1])
         {
            if (trend5[whichBar] ==  1) doAlert(time5,mess5,whichBar," touching R1 Fib up ");
            if (trend5[whichBar] == -1) doAlert(time5,mess5,whichBar," touching R1 Fib down ");
         }
      static datetime time6 = 0;
      static string   mess6 = "";
         if (alertsOnFibR2Touch && trend6[whichBar] != trend6[whichBar+1])
         {
            if (trend6[whichBar] ==  1) doAlert(time6,mess6,whichBar," touching R2 Fib up ");
            if (trend6[whichBar] == -1) doAlert(time6,mess6,whichBar," touching R2 Fib down ");
         }
      static datetime time7 = 0;
      static string   mess7 = "";
         if (alertsOnFibR3Touch && trend7[whichBar] != trend7[whichBar+1])
         {
            if (trend7[whichBar] ==  1) doAlert(time7,mess7,whichBar," touching R3 Fib up ");
            if (trend7[whichBar] == -1) doAlert(time7,mess7,whichBar," touching R3 Fib down ");
         } 
   }
return(0);
}

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" AutoDayFibs "+doWhat;
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," AutoDayFibs "),message);
             if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," AutoDayFibs " +" "+message));
             if (alertsSound)   PlaySound(soundFile);
      }
}